let Service = Services(PBConstants.BASE_API_URL, PBConstants.MARKET_CAP_API_URL, PBConstants.CURRENCIES_API_URL, PBConstants.LOGS_API_URL);
var currentlyEditing = 'default';
let NormalizerService = Service.Normalizer;
let configFiles = ['PAIRS', 'DCA', 'INDICATORS'];
let advancedOn = LS.gI(NormalizerService.generateLocalStorageKey('advancedOn'));

/*
 ************* MODALS ***************
 * SweetAlert modal functions called by eventListeners
 */
let Modals = (function () {

    function switchConfigModal(e) {
        let configName = e.target.value;
        swal(i18next.t('alertMsgs.sureText'), {
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.confirmText') + configName + '!'
            },
            text: i18next.t('alertMsgs.switchConfigText') + configName + '!',
            icon: "warning",
            showCancelButton: true,
            closeOnConfirm: false,
            confirmButtonColor: '#DD6B55',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then((value) => {
            if (value) {
                switchActiveConfig(configName);
                swal(i18next.t('alertMsgs.switchedText'));
                $(document).trigger('evt.load-page-data');
            } else {
                let switchBack = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];
                d.gEBI("switchActiveConfig").value = switchBack;
            }
        }).catch(error => console.log('canceled ' + error));
    }

    function hotModal() {
        let activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];

        swal(i18next.t('alertMsgs.hotConfig') + activeConfig, {
            content: {
                element: "input",
                attributes: {
                    className: "form-control swal-input",
                    placeholder: i18next.t('alertMsgs.inputPlaceholder'),
                }
            },
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.submitBtn')
            },
            showCancelButton: true,
            confirmButtonColor: '#3BAFDA',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then((value) => {
            if (value) {
                Service.saveConfigFile("HOTCONFIG", value, activeConfig);
                swal(i18next.t('alertMsgs.sent') +" "+ value + i18next.t('alertMsgs.to') + activeConfig + '.');
            }
        }).catch(error => console.log('canceled ' + error));
    }

    function resetBotModal() {
        swal({
            title: i18next.t('alertMsgs.resetQues'),
            text: i18next.t('alertMsgs.resetTestModeData'),
            icon: "warning",
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.reset')
            },
            showCancelButton: true,
            confirmButtonColor: '#DD6B55',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then((value) => {
            if (value) {
                Service.resetProfitTrailer();
                swal( i18next.t('alertMsgs.resettingPT'))
            }
        }).catch(error => console.log('canceled ' + error));
    }
     function panicSellModal(e) {
        swal({
            title: i18next.t('alertMsgs.panicSell'),
            text: i18next.t('alertMsgs.turningOnPanicSellWarning'),
            icon: "warning",
            buttons: {

                confirm: i18next.t('alertMsgs.ok')
            },
            showCancelButton: false,
            confirmButtonColor: '#DD6B55',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then(

            changeSettingHandler(e)
        ).catch(error => console.log('canceled ' + error));
    }
    function removeConfigModal() {
        swal(i18next.t('alertMsgs.sureText'), {
            title: i18next.t('alertMsgs.sureText'),
            text: i18next.t('alertMsgs.recoverFile'),
            icon: "warning",
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.submitBtn')
            },
            showCancelButton: true,
            confirmButtonColor: '#DD6B55',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then((value) => {
            if (value) {
                removeConfigFileHandler();
                swal(i18next.t('alertMsgs.deleted'));
            }
        }).catch(error => console.log('canceled ' + error));
    }

    function newConfigNameModal() {
        let editingConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingConfig'];
        let maxConfigsAllowed = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['maxConfigsAllowed'];
        if (LS.gO(NormalizerService.generateLocalStorageKey('settings'))['availableConfigs'].length < maxConfigsAllowed) {
	        swal({
	            title: i18next.t('alertMsgs.newConfigName'),
	            text: i18next.t('alertMsgs.copiedToNewConfig', {editingConfig: editingConfig}),
	            content: {
	                element: "input",
	                attributes: {
	                    className: "form-control swal-input",
	                    placeholder: i18next.t('alertMsgs.newConfigurationName'),
	                }
	            },
	            buttons: {
	                cancel: i18next.t('alertMsgs.cancelBtn'),
	                confirm: i18next.t('alertMsgs.save')
	            },
	            showCancelButton: true,
	            confirmButtonColor: '#DD6B55',
	            closeOnConfirm: true,
	            closeOnCancel: true
	        }).then((value) => { newConfigNameInputSave(value); })
	    } else {
	        swal(i18next.t('alertMsgs.maxConfigurations', {maxConfigsAllowed: maxConfigsAllowed}));
	    }
    }

    function buyOrSellModal(e) {
        if (e.target.classList.contains('cancel-pending')) {
            swal(e.target.dataset.buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?', {
                title: e.target.dataset.buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: i18next.t('alertMsgs.cancelOrderConfirm', {orderNumber: e.target.dataset.orderNumber, pair: e.target.dataset.pair}),
                icon: "warning",
                buttons: {
                    cancel: i18next.t('alertMsgs.exit'),
                    confirm: i18next.t('alertMsgs.cancelOrderBtn', {orderNumber: e.target.dataset.orderNumber})
                },
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                closeOnConfirm: true,
                closeOnCancel: true
            }).then(function (value) {
                return value ? Service.cancelPending(e.target.dataset.pair, e.target.dataset.orderNumber) : null;
            });
        } else {
            swal(e.target.dataset.buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?', {
                title: e.target.dataset.buyOrSell.toUpperCase() + ' ' + e.target.dataset.pair + '?',
                text: '' + i18next.t('alertMsgs.sureTo') + e.target.dataset.buyOrSell + ' ' + e.target.dataset.pair + '?',
                icon: "warning",
                buttons: {
                    cancel: i18next.t('alertMsgs.cancelBtn') + " " + e.target.dataset.pair,
                    confirm: e.target.dataset.buyOrSell.toUpperCase()
                },
                showCancelButton: true,
                confirmButtonColor: '#DD6B55',
                closeOnConfirm: true,
                closeOnCancel: true
            }).then(function (value) {
                if (value) {
                    Service.buyOrSellPair(e.target.dataset.buyOrSell, e.target.dataset.pair);
                    (function spinnersInBadges() {
                        var badges = document.getElementsByClassName("records-count");
                        Array.prototype.forEach.call(badges, function (badge) {
                            badge.innerHTML = '<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>';
                        });
                    })();
                }
            });
        }
    }

    function toolTipModal(e) {
        let setting = e.target.getAttribute('for');
        let settingKeys = Object.keys(tooltips);
        let lowerKeys = settingKeys.join('|').toLowerCase().split('|');

        let showSetting = lowerKeys.indexOf(setting)

        if (tooltips[settingKeys[showSetting]]) {
            swal(i18next.t('alertMsgs.setting') +
                e.target.getAttribute('for') + "\n\n" +
                tooltips[settingKeys[showSetting]].toolTip, {
                    title: e.target.innerHTML
                })
        } else {
            swal(i18next.t('alertMsgs.noTip'))
        }
    }

    function publishConfigModal() {
        var activeConfig = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['configName'];
        swal(i18next.t('alertMsgs.shareConfirm', {activeconfig: activeConfig}), {
            icon: "images/Logo.png",
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.share')
            },
            showCancelButton: true,
            confirmButtonColor: '#DD6B55',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then(function (result) {
            Service.publishActiveSetting();
        }, function (dismiss) {
            swal(i18next.t('alertMsgs.maybeLater'));
        });
    }

    function blackListModal() {
        const settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        const eCfg = settingsObj['editingConfig']
        let newdiv = document.createElement('DIV')
        newdiv.classList = "d-flex justify-content-center"
        let blackListNav = document.createElement('DIV')
        blackListNav.classList = "d-flex justify-content-center p-t-0 m-0"
        let iconarr = ['fa fa-list listblack blacklistb', 'fa fa-list listwhite blacklistw', 'fa fa-adjust listwhite blacklistbw']
        iconarr.map(function (icons) {
            let icon = document.createElement('I')
            icon.classList = icons;
            icon.style.cursor = 'pointer'
            if (icons.includes('blacklistw')) {
                icon.style.color = 'white'

                icon.setAttribute("title", "Whitelist")
            }
            if (icons.includes('blacklistb')) {
                icon.style.color = 'black'

                icon.setAttribute("title", "Blacklist")
            }
            if (icons.includes('blacklistbw')) {
                icon.style.color = 'white'

                icon.setAttribute("title", "All")
            }
            icon.style.fontSize = '30px';
            icon.style.padding = '0px 50px 15px 50px';
            blackListNav.appendChild(icon)
        })
        let col1 = document.createElement('DIV')
        col1.classList = "col card-box"
        col1.style.height = "55vh"
        col1.appendChild(blackListNav)
        col1.appendChild(fillBlackList())
        newdiv.appendChild(col1)
        swal({
            content: {
                element: newdiv,
                attributes: {
                    className: "",
                    placeholder: i18next.t('footer.pt'),
                }
            },
            buttons: {
                cancel: i18next.t('alertMsgs.cancelBtn'),
                confirm: i18next.t('alertMsgs.save')
            },
            showCancelButton: true,
            confirmButtonColor: '#3BAFDA',
            closeOnConfirm: true,
            closeOnCancel: true
        }).then(function (result) {
            if (result) {
                saveForm('PAIRS', true)
            } else {
                storeConfigLoadForEdit(eCfg)
            }
        }).catch(error => console.log('canceled ' + error));
    }

    return {
        switchConfigModal,
        hotModal,
        resetBotModal,
        removeConfigModal,
        newConfigNameModal,
        buyOrSellModal,
        toolTipModal,
        publishConfigModal,
        blackListModal,
        panicSellModal
    };
})();
/***********************************/

/*
 ************* eventListeners ********
 *
 */
document.addEventListener('change', function (event) {
    if (event.target.id === "tgl-buy-or-sell-btns") {
        toggleBuySellButtonVis(event.target.checked)
    }
    if (event.target.id === 'pairsmenu') {
        //console.log(event.target.value)
        switchConfigFormCoinSpecific(event.target.value);
        //allSets();
    }
    if (event.target.classList.contains('config-dropdown')) {

        storeConfigLoadForEdit(event.target.value)
    }
    if (event.target.id === 'advConfigSwitch') {
        toggleAdvancedHandler(event.target);
    }
    if (event.target.id === 'switchActiveConfig') {
        Modals.switchConfigModal(event);
    }
    if (event.target.classList.contains('config-input')) {
    let panicRegex = new RegExp(/.*_panic_sell_enabled/, 'i')
        if (event.target.value.includes(',')) {
            event.target.title = event.target.value
        }
        // Only show Panic Sell modal when switching from FALSE to TRUE
        if(event.target.id.match(panicRegex) && event.target.checked === true){
            Modals.panicSellModal(event.target);
        } else {
        changeSettingHandler(event.target);
        }
    }
}, false);

document.addEventListener('mousedown',function(event){
    if (event.target.classList.contains('acetab')) {

        if(unsavedChangesCheck()){
            event.preventDefault()

             swal(i18next.t('alertMsgs.unsavedChangesOnThisTab'), {
                icon: "images/Logo.png",
                buttons: {
                    cancel: {
                        text: i18next.t('alertMsgs.cancelBtn'),
                        value: null,
                        visible: true,
                        className: "",
                        closeModal: true,
                      },
                      confirm: {
                        text: i18next.t('alertMsgs.ok'),
                        value: true,
                        visible: true,
                        className: "",
                        closeModal: false
                      }

                },
                confirmButtonColor: '#DD6B55',


            }).then(function(isConfirm){
                if (isConfirm) {

               return     aceSave().then((result) => {
                if (result === 'success') {
                    loadACE(event.target.dataset.settingType);
                    event.target.click()
                    swal.close();
                }
              })
               }else{
                     swal(i18next.t('alertMsgs.cancelled'), i18next.t('alertMsgs.fileStillUnsaved'), "error");
               }
            })
        }
}
})

document.addEventListener('mouseup', function (event) {
    if (event.target.id === 'blackListButton') {
        Modals.blackListModal();
    }
    if (event.target.classList.contains('blackListItem')) {
        let param;
        let paramVal = '';
        if (event.target.classList.contains('blMode')) {
            param = event.target.innerHTML + "_trading_enabled"
            if (!event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingON')
                event.target.classList.add('tradingOFF')
                paramVal = 'false';
            } else if (event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingOFF')
                event.target.classList.add('tradingON')
                paramVal = 'true';
            }
        } else if (event.target.classList.contains('epMode')) {
            param = 'enabled_pairs';
            let epname = new RegExp(/enabled_pairs/, 'i');
            let eCfg = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingConfig'];
            let ep = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['files'][eCfg]['PAIRS']['enabled_pairs'];
            ep = ep.toUpperCase().split(',').map(Function.prototype.call, String.prototype.trim);
            if (!event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingON')
                event.target.classList.add('tradingOFF')
                ep = ep.filter(e => e !== event.target.innerHTML);
                paramVal = ep.join(',')
            } else if (event.target.classList.contains('tradingOFF')) {
                event.target.classList.remove('tradingOFF')
                event.target.classList.add('tradingON')
                ep.push(event.target.innerHTML);

                paramVal = ep.join(',');
            }

        }

        changeSetting('PAIRS', param, paramVal)
    }
    if (event.target.classList.contains('listblack') || event.target.classList.contains('listwhite')) {
        if (event.target.classList.contains('blacklistb')) {
            d.qSA('.tradingON').forEach(
                function (tOffel) {
                    tOffel.style.display = 'none';
                }
            )
            d.qSA('.tradingOFF').forEach(
                function (tOffel) {
                    tOffel.style.display = 'block';
                }
            )

        } else if (event.target.classList.contains('blacklistw')) {
            d.qSA('.tradingOFF').forEach(
                function (tOffel) {
                    tOffel.style.display = 'none';
                }
            )
            d.qSA('.tradingON').forEach(
                function (tOffel) {
                    tOffel.style.display = 'block';
                }
            )

        } else if (event.target.classList.contains('blacklistbw')) {
            d.qSA('.tradingOFF').forEach(
                function (tOffel) {
                    tOffel.style.display = 'block';
                }
            )
            d.qSA('.tradingON').forEach(
                function (tOffel) {
                    tOffel.style.display = 'block';
                }
            )
        }
    }
    if (event.target.id === 'basic-hotconfig') {
        Modals.hotModal()
    }
    if (event.target.id === 'saveButton' || event.target.classList.contains('save-config-form')) {
        $('#config-save-loader').css('visibility', $('#config-save-loader').css('visibility') == 'hidden' ? 'visible' : 'hidden');
        

        let saveThrottled = RateLimit(saveForm, 1000);
        ['PAIRS', 'DCA', 'INDICATORS'].forEach((file) => saveThrottled(file));

        
    }
    if (event.target.classList.contains('save-config')) {
        $('#config-save-loader-ace').css('visibility', $('#config-save-loader-ace').css('visibility') == 'hidden' ? 'visible' : 'hidden');
        aceSave();
    }
    if (event.target.classList.contains('btnReset')) {
        if (event.target.classList.contains('disabled')) {
            return;
        }
        Modals.resetBotModal();
    }
    if (event.target.classList.contains('formstabs')) {
        let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
        let fileName = event.target.dataset.settingType;
        obj['editingFile'] = fileName
        updateGuiConfigFields(fileName)
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), obj)
    }
    if (event.target.classList.contains('acetab')) {

        let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
        obj['editingFile'] = event.target.dataset.settingType
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), obj)
        loadACE(event.target.dataset.settingType);

    }
    if (event.target.classList.contains('removeConfig')) {
        Modals.removeConfigModal();
    }
    if (event.target.classList.contains('new-config-name')) {
        Modals.newConfigNameModal();
    }
    if (event.target.classList.contains('buy-or-sell-btn')) {
        Modals.buyOrSellModal(event);
    }
    if (event.target.classList.contains('control-label')) {
        Modals.toolTipModal(event);
    }
    if (event.target.classList.contains('share-config')) {
        Modals.publishConfigModal();
    }
    if (event.target.classList.contains('backup-config')) {
        backup();
    }
    if (event.target.classList.contains('plusminus')) {
        plusMinusHandler(event.target)
    }
    if (event.target.classList.contains('plusminusi')) {
        plusMinusHandler(event.target.parentElement)
    }

    
}, false);
/***********************************/

/*
 ************* Initialization ********
 * Fired in script.js
 */
function configInit() {

    storeConfigFiles();
    enableTestModeButtons();
    startupTest();
    toggleBuySellButtonsSwitch();
    toggleAdvanced();
    d.qSA('.control-label').forEach(function (x) {
        x.classList.add('tool-tip')
    })
}
/***********************************/
function enableEditor(tof) {
    let editor = DomHelper.getGlobalEditor('PBConfigEditor');
    tof ? editor.container.style.opacity = 1 : editor.container.style.opacity = 0.3;
    tof ? editor.container.style.pointerEvents = "all" : editor.container.style.pointerEvents = "none"
    tof ? editor.renderer.setStyle("disabled", false) : editor.renderer.setStyle("disabled", true)
    tof ? editor.focus() : editor.blur();
    tof ? editor.textInput.getElement().disabled = false : editor.textInput.getElement().disabled = true;

    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    if (!tof && settingsObj != null && settingsObj['editingFile'] !== 'HOTCONFIG') {
        editor.session.setValue('Loading...', -1);
    }

}

function unsavedChangesCheck(){
    let saveEl = d.qS('.show-save-message');
    return saveEl.classList.contains('not-saved')
}

function aceSave(){
    return new Promise(function (resolve, reject) {
    let editor = DomHelper.getGlobalEditor('PBConfigEditor');
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        let filename = settingsObj['editingFile'];
        let configName = settingsObj['editingConfig'];
        let updatedData = editor.getValue();
        esvJSON(updatedData).then(function (output) {
            settingsObj['files'][configName][filename] = output;
            LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        });
        Service.saveConfigFile(filename, updatedData, configName).done(function (jqXHR,data) {
           // console.log(data)
            if (data === 'success') {
                notSaved('hide');
                toastr.success(i18next.t('constantMsgs.configSuccess'));
                $('#config-save-loader-ace').css('visibility', $('#config-save-loader-ace').css('visibility') == 'hidden' ? 'visible' : 'hidden');
            } else if (data !== 'success') {
                toastr.info(i18next.t('constantMsgs.ajaxError'));
            }
            resolve(data)
        });
    })
}

function plusMinusHandler(plusMinus) {
    if (plusMinus.classList.contains('badge-danger')) {
        plusMinus.classList.remove('badge-danger');
        plusMinus.classList.add('badge-success');
        plusMinus.innerHTML = '<span class="fa fa-plus plusminusi"></span>';
        let classNameList =
            plusMinus.parentElement.parentElement
            .getElementsByClassName('config-input');
        for (let i = 0; i < classNameList.length; i++) {
            el = classNameList[i];
            el.disabled = true;
            changeSetting(String(el.dataset.settingType), String(el.id), "remove")
            if (el.tagName == 'SELECT') {
                el.value = "Choose...";
            } else {
                el.value = '';
            }
            notSaved('show');
        }
    } else if (plusMinus.classList.contains('badge-success')) {
        plusMinus.innerHTML = '<span class="fa fa-minus plusminusi"></span>';
        plusMinus.classList.remove('badge-success');
        plusMinus.classList.add('badge-danger');
        let classNameList =
            plusMinus.parentElement.parentElement
            .getElementsByClassName('config-input');
        for (let i = 0; i < classNameList.length; i++) {
            el = classNameList[i];
            el.disabled = false;
        }
    }
}

function togglePlusMinus() {
    let minusButtons = d.qSA('.plusminus'),
        result;
    for (let i = 0; i < minusButtons.length; i++) {
        result = minusButtons[i];
        let classNameList = result.parentElement.parentElement.parentElement.getElementsByClassName('config-input');
        if (!classNameList[1].disabled) {
            result.classList.remove('badge-success');
            result.classList.add('badge-danger');
            result.innerHTML = '<span class="fa fa-minus plusminusi"></span>';
        } else {
            result.classList.remove('badge-danger');
            result.classList.add('badge-success');
            result.innerHTML = '<span class="fa fa-plus plusminusi"></span>';
        }
    }
}

function enableTestModeButtons() {
    Service.getTableData().then(function (x) {
        let testy = d.qSA('.testmode');
        if (x.settings.testMode) {
            Array.prototype.forEach.call(testy, function (el) {
                el.classList.remove('disabled')
            })
        } else {
            Array.prototype.forEach.call(testy, function (el) {
                el.classList.add('disabled')
            })
        }
    })
}

function esvJSON(esv) {
    return new Promise(function (resolve, reject) {
        esv = Array.isArray(esv) ? esv.join('\n') : esv;
        let lines = esv.split("\n");
        let result = [];
        for (let i = 0; i < lines.length; i++) {
            let obj = [];
            let currentLine = lines[i].trim();

            if (currentLine.startsWith('#') || currentLine === "") {
                obj.push("comment-" + i, currentLine);
                result.push(obj);
            } else if(lines[i].indexOf('=') !== -1) {
                obj.push(lines[i].split("=")[0].trim(), lines[i].split("=")[1].trim())
                result.push(obj);
            } else {
                obj.push(lines[i]);
                result.push(obj);
            }
        }
        result = result.reduce(function (p, c) {
            p[c[0]] = c[1];
            return p;
        }, {});
        resolve(result); //JSON
    })
}

function storeConfigFiles() {
    let storedObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let settingsObj = {};
    Service.getTableData().done(function (x) {
        settingsObj.availableConfigs = JSON.parse(x.settings.availableConfigs);
        settingsObj.maxConfigsAllowed = JSON.parse(x.settings.maxConfigsAllowed);
        settingsObj.configName = x.settings.activeConfig;
        settingsObj.market = x.market;
        settingsObj.exchange = x.exchange;

        let containsConfig = storedObj != null && $.inArray(storedObj['editingConfig'], settingsObj.availableConfigs) != -1;
        (!containsConfig) ? settingsObj.editingConfig = x.settings.activeConfig : settingsObj.editingConfig = storedObj['editingConfig'];
        (!containsConfig) ? settingsObj.editingFile = 'PAIRS' : settingsObj.editingFile = storedObj['editingFile'];

        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        storeConfigLoadForEdit(settingsObj.editingConfig)
    })
}

function storeConfigLoadForEdit(configName) {
    let mainform = d.gEBI('mainform');
    resetConfigForm(mainform);
    enableEditor(false)
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let activeconfig = settingsObj['configName']
    let editingFile = settingsObj['editingFile']
    settingsObj['editingConfig'] = configName;
    let deletebtns = d.gEBCN('removeConfig');
    let sharebtn = d.gEBCN('share-config');
    let advancedOn = LS.gI(NormalizerService.generateLocalStorageKey('advancedOn'));
    let hotconfigBtn = d.gEBI("basic-hotconfig");
    let $configSwitcherContainer = $('.config-switcher-container');
    LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
    settingsObj['files'] = {};
    settingsObj['files'][configName] = {}

testarray = []
    configFiles.forEach(function (filename) {
        settingsObj['files'][configName][filename] = {};
       testarray.push( Service.getConfigFile(filename, configName)
            .done(function (data) {
                // Returning if data is empty string.
                if (!data) {
                    return;
                }
                data = JSON.parse(data);
                data ? esvJSON(data).then(function (output) {
                        settingsObj['files'][configName][filename] = output;
                        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
                        eachSetting(output);
                        if (editingFile === filename) {
                            loadACE(filename)

                        }
                    }) :
                    toastr.info(i18next.t('constantMsgs.ajaxError'));
            }));

    });
    Promise.all(testarray).then(() => {
enableEditor(true)
       }).catch(() => {
        // all requests finished but one or more failed
        console.log('caught error')
       })
    if (activeconfig === configName) {
        Array.prototype.map.call(deletebtns, function (x) {
            x.style.display = "none"
        })
        Array.prototype.map.call(sharebtn, function (btns) {
            btns.style.display = "inline-block"
        })
        hotconfigBtn.style.display = "inline-block";
        $configSwitcherContainer.addClass('active-config-container')
    } else {
        Array.prototype.map.call(deletebtns, function (x) {
            x.style.display = "inline-block"
        });
        Array.prototype.map.call(sharebtn, function (btns) {
            btns.style.display = "none"
        })
        hotconfigBtn.style.display = "none";
        $configSwitcherContainer.removeClass('active-config-container')
    }
    d.gEBI('configDropdown').value = configName;
    d.gEBI('configDropdown2').value = configName;
}
function showBuySellButtons() {
    return LS.gI(NormalizerService.generateLocalStorageKey('showBuySellButtons'));
}

function toggleBuySellButtonVis(val) {
    LS.sI(NormalizerService.generateLocalStorageKey('showBuySellButtons'), val)
    if (val === true) {
        d.qSA('.buy-or-sell-btn').forEach(function (x) {
            if (x.classList.contains('hide')) {
                x.classList.remove('hide')
            }
        })
    } else if (val === false) {
        d.qSA('.buy-or-sell-btn').forEach(function (x) {
            if (!x.classList.contains('hide')) {
                x.classList.add('hide')
            }
        })
    }
}

function toggleBuySellButtonsSwitch() {
    let showBuySellButtons = LS.gI(NormalizerService.generateLocalStorageKey('showBuySellButtons'))
    let buysellSwitch = d.gEBI('tgl-buy-or-sell-btns');
    if (showBuySellButtons === 'false') {
        buysellSwitch.checked = false;
    } else {
        buysellSwitch.checked = true;
    }
}
function startupTest(){
    !LS.gI(NormalizerService.generateLocalStorageKey('advancedOn')) ? LS.sI(NormalizerService.generateLocalStorageKey('advancedOn'), false):null;
    !LS.gI(NormalizerService.generateLocalStorageKey('showBuySellButtons')) ? LS.sI(NormalizerService.generateLocalStorageKey('showBuySellButtons'), false):null;
}

function setadvancedOn(value) {
    if (!value) {
        LS.sI(NormalizerService.generateLocalStorageKey('advancedOn'), false);
    } else {
        LS.sI(NormalizerService.generateLocalStorageKey('advancedOn'), true);
    }
}

function toggleAdvanced() {
    let advancedOn = LS.gI(NormalizerService.generateLocalStorageKey('advancedOn'))
    let advSwitch = d.gEBI('advConfigSwitch');
    if (advancedOn === 'false') {
        advSwitch.checked = false;
    } else {
        advSwitch.checked = true;
    }
}

function toggleAdvancedHandler(input) {
    let acetabs = d.qSA('#acetabs > ul > li > a')
    let configtabs = d.qSA('#configTabContainer > ul > li > a');
    let configtabscontent = document.querySelectorAll(
      '#configTabContainer > .tab-content > .tab-pane'
    );
    let eFile = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingFile'];
    let eCfg = LS.gO(NormalizerService.generateLocalStorageKey('settings'))['editingConfig'];
    setadvancedOn(input.checked);
    if (input.checked) {
        toggleConfigVisibility(true);
        acetabs.forEach(function (x) {
            if (x.innerHTML.toLowerCase().match(eFile.toLowerCase())) {
                x.classList.add('active')
            } else {
                x.classList.remove('active')
            }
        });
    } else {
        toggleConfigVisibility(false);
        togglePlusMinus();
        configtabs.forEach(function (x) {
            if (x.innerHTML.toLowerCase().match(eFile.toLowerCase())) {
                x.click()
            }
        });
        configtabscontent.forEach(function (x) {
	        if (
	          x.id
	          .toLowerCase()
	          .match(eFile.toLowerCase())
	        ) {
	          x.classList.add('show');
	          x.classList.add('active');
	        } else {
	          x.classList.remove('show');
	          x.classList.remove('active');
	        }
	      });
    }
    loadACE(eFile)
    updateGuiConfigFields(eFile)
  //storeConfigLoadForEdit(eCfg)
}

function toggleConfigVisibility(advanced) {
    let configForm = d.gEBI('config-form');
    let aceContainer = d.gEBI('configurationContainer');
    if (advanced) {
        configForm.style.display = 'none';
        aceContainer.style.display = 'block';
    } else {
        configForm.style.display = 'block';
        aceContainer.style.display = 'none';
    }
}

function switchConfigFormCoinSpecific(pair) {


    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    d.qSA('.config-input').forEach(function (x) {
        if (d.qS('label[for=' + x.id + ']')) {
            d.qS('label[for=' + x.id + ']').htmlFor = x.getAttribute('id').replace(currentlyEditing, pair)
            x.id = x.getAttribute('id').replace(currentlyEditing, pair);
            x.name = x.getAttribute('id').replace(currentlyEditing, pair);
        }

    });
    currentlyEditing = pair;

allSets();
   // storeConfigLoadForEdit(settingsObj['editingConfig'])
}

function switchActiveConfig(configName) {
    Service.switchConfigFile(configName);
}

function removeConfigFile(configName) {
    Service.removeConfigFile(configName);
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    let currentConfig = settingsObj['configName'];
    let availableConfigs = settingsObj['availableConfigs']
    let filteredConfigList = availableConfigs.filter(
        function (item) {
            return item !== configName
        });
    settingsObj['availableConfigs'] = filteredConfigList;
    settingsObj['editingConfig'] = currentConfig
    LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
    storeConfigLoadForEdit(currentConfig);
}

function removeConfigFileHandler() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'))
    let currentConfig = settingsObj['configName'];
    let editConfig = settingsObj['editingConfig'];
    if (editConfig !== currentConfig) {
        removeOption('#configDropdown', editConfig);
        removeOption('#configDropdown2', editConfig);
        removeOption('#switchActiveConfig', editConfig);
        removeConfigFile(editConfig);
    }
}

function addOption(selector, nameValue) {
    const nodeList = d.qSA(selector);
    return nodeList.forEach(function(data, index) {
        let optEl = document.createElement('option');
        optEl.innerHTML = nameValue;
        optEl.value = nameValue;
        data.appendChild(optEl);
    });
}

function clearMenus(selector) {
    const nodeList = d.qSA(selector);
    nodeList.forEach(function(el) {
        el.innerHTML = '';
    })
}

function removeOption(selector, match) {
    const nodeList = d.qSA(selector);
    Array.prototype.map.call(nodeList, function (data, index) {
        return Array.prototype.map.call(data, function (item) {
            String(item.innerHTML).match(match) ||
                String(item.value).match(match) ? data.remove(item.index) : null;
        });
    });
}

function loadPairsMenu() {
    let pairsmenu = d.gEBI('pairsmenu');
    for (let i = 0; i < LS.gO(NormalizerService.generateLocalStorageKey('validPairs')).length; i++) {
        let opt = document.createElement('option');
        opt.innerHTML = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'))[i];
        opt.value = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'))[i].toLowerCase();
        pairsmenu.appendChild(opt);
    }
}

function fillBlackList() {
    let fullList = []
    let validpairsarr = LS.gO(NormalizerService.generateLocalStorageKey('validPairs'));
    const settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    const eCfg = settingsObj['editingConfig']
    const allowed = new RegExp(/^(?!#.*$).*_trading_enabled/, 'gi');
    const falseRegex = new RegExp(/.*false.*/, 'i');
    const allRegex = new RegExp(/.*all.*/, 'i');
    let list = document.createElement('ul');
    let item;
    let listTypeClass;
    let whitelist;
    let invalidPairs;
    let filteredBlacklist;
    let blackList = [];
    const raw = settingsObj['files'][eCfg]['PAIRS'];
    const rawKeys = Object.keys(raw);
    const enabledPairsCheck = rawKeys.indexOf('enabled_pairs');
    const typedName = rawKeys[enabledPairsCheck];
    const filtered = rawKeys.filter(key => key.match(allowed)).reduce((obj, key) => {
        if (raw[key].match(falseRegex)) {
            obj[key] = raw[key]
        }
        return obj;
    }, {});
    if (typedName !== undefined && !raw[typedName].match(allRegex)) {
        listTypeClass = 'epMode'
        console.log('enabled_pairs is present')
        whitelist = raw[typedName].toUpperCase().split(',').map(Function.prototype.call, String.prototype.trim);
        filteredBlacklist = validpairsarr.diff(whitelist)
    } else {
        console.log('XXX_trading_enabled is the blacklist format')
        Object.keys(filtered).forEach(function (listItems) {
            blackList.push(listItems.split('_')[0].toUpperCase())
        });
        whitelist = validpairsarr.diff(blackList)
        invalidPairs = blackList.diff(validpairsarr)
        filteredBlacklist = blackList.diff(invalidPairs)
        listTypeClass = 'blMode'
    }
    filteredBlacklist.map(function (pair) {
        fullList.push([pair, "tradingOFF"])
    })
    whitelist.map(function (pair) {
        fullList.push([pair, "tradingON"])
    })
    fullList = fullList.sort()
    list.classList = 'list-group list-group-flush'
    list.style.overflowY = 'scroll';
    list.style.height = '50vh'

    for (let i = 0; i < fullList.length; i++) {
        item = document.createElement('li');
        item.classList = 'list-group-item blackListItem ' + listTypeClass + " " + fullList[i][1]
        item.appendChild(document.createTextNode(fullList[i][0]));
        list.appendChild(item);
    }
        return list;
}

function loadMarketLabels() {
    d.qSA('label[for^=price_]').forEach(function (x) {
        let y = x.innerHTML;
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        let configName = settingsObj['configName']
        let ptm = settingsObj['files'][configName]['PAIRS']['price_trigger_market']
        x.innerHTML = ptm + ' ' + y.split(' ').slice(1).join(' ');
    })
}

function resetConfigForm(element) {
    return new Promise(function (resolve, reject) {
        let result = 'Done clearing children of form';
        for (let i = 0; i < element.childNodes.length; i++) {
            let e = element.childNodes[i];
            if (e.tagName) switch (e.tagName.toLowerCase()) {
                case 'input':
                    switch (e.type) {
                        case "radio":
                        case "checkbox":
                            e.checked = false;
                            break;
                        case "button":
                        case i18next.t('alertMsgs.submitBtn'):
                        case "image":
                            break;
                        default:
                            e.value = '';
                            !e.classList.contains('keepEnabled') ? e.disabled = true : e.disabled = false;
                            break;
                    }
                    break;
                case 'select':
                !e.classList.contains('keepEnabled') ? e.disabled = true : e.disabled = false;
                    break;
                case 'textarea':
                    e.innerHTML = '';
                    break;
                default:
                    resetConfigForm(e);
            }
        }
        resolve(result);
    });
}

function changeSetting(filePath, setting, value) {

    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let settingKeys = Object.keys(settingsObj['files'][settingsObj['editingConfig']][filePath]);
    let lowerKeys = settingKeys.toLocaleString().toLowerCase().split(',')
    let settingIndex = lowerKeys.indexOf(setting)
    let newSettingName = '';
    if (settingIndex !== -1) {
        newSettingName = settingKeys[settingIndex];
    } else {
        newSettingName = setting;
    }
    if (value === "remove") {
        delete settingsObj['files'][settingsObj['editingConfig']][filePath][newSettingName]
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
    } else {
        settingsObj['files'][settingsObj['editingConfig']][filePath][newSettingName] = value;
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj)
    }
}

function changeSettingHandler(target) {
    notSaved('show');
    let obj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let filePath = target.dataset.settingType;
    obj = obj['files'][obj['editingConfig']][filePath]
    let settingKeys = Object.keys(obj);
    target.classList.add("newback")
    let setting = target.getAttribute('id');
    let lowerKeys = settingKeys.toLocaleString().toLowerCase().split(',')
    let settingIndex = lowerKeys.indexOf(setting)
    let realName = '';
    if (settingIndex !== -1) {
        realName = settingKeys[settingIndex]
    } else {
        realName = setting;
    }
    let value = '';
    let partsOfStr;
    if (target.getAttribute('type') == 'checkbox') {
        value = String(target.checked);
        changeSetting(filePath, realName, value);
    } else
        value = target.value;
    if (!value.includes(',') || target.getAttribute('type') == 'checkbox') {
        for (key in obj) {
            if (String(key)
                .includes(String(realName))) {
                delete obj[key];
            }
        }
        changeSetting(filePath, realName, value);
    } else if (value.includes(',')) {
        let dcaBuyPercentageMatch =
            new RegExp(/.*dca_buy_percentage/, 'i');
        let dcaBuyTriggerMatch =
            new RegExp(/.*dca_buy_trigger/, 'i');
        let buyOrSellStrategy =
            new RegExp(/.*_strategy/, 'i');
        let dcaSellTriggersMatch =
            new RegExp(/.*dca_[A-Z]_sell_value_.*/, 'i');
        settingKeys.map(function (x) {
            if (x.match(dcaBuyPercentageMatch) || x.match(dcaBuyTriggerMatch) || x.match(buyOrSellStrategy) || x.match(dcaSellTriggersMatch)) {
                changeSetting(filePath, x, "remove");
            }
        })
        partsOfStr = value.split(',');
        partsOfStr.forEach(function (x, y) {
            let newdex = y + 1;
            let newsetting = realName + "_" + newdex;
            newval = x;
            changeSetting(filePath, newsetting, newval);
        });
    } else
        changeSetting(filePath, realName, value);
}

function allSets() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let mainform = d.gEBI('mainform');
    let eCfg = settingsObj['editingConfig'];
    let pairs = settingsObj['files'][eCfg]['PAIRS']
    let dca = settingsObj['files'][eCfg]['DCA']
    let ind = settingsObj['files'][eCfg]['INDICATORS']
    d.gEBI('configDropdown').value = eCfg;
    d.gEBI('configDropdown2').value = eCfg;
    resetConfigForm(mainform);
    [pairs, dca, ind].map(function (x) {
        eachSetting(x)
    })
}
function findCombined() {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let mainform = d.gEBI('mainform');
    let eCfg = settingsObj['editingConfig'];
    let pairs = filterCombine(Object.keys(settingsObj['files'][eCfg]['PAIRS']))
    let dca = filterCombine(Object.keys(settingsObj['files'][eCfg]['DCA']))
  //  console.log(pairs.length, dca.length)
    let totarr = [...pairs, ...dca]
   // console.log(totarr)
    let dcac = document.querySelector('.dcacombined')
    let pairsc = document.querySelector('.pairscombined');
   let notset = [dcac.id, pairsc.id].diff(totarr)
   notset.forEach(function(y){
       let newel = d.gEBI(y);
       newel.checked = true;
   })

}

function filterCombine(array){
let combinedPendingSwitch =
        new RegExp(/.*[^?dca]combine_pending_orders/,'i');
    let filteredCombined = array.filter(
        function (item) {
            return item.match(combinedPendingSwitch)
        });
        return filteredCombined;
}

function updateGuiConfigFields(fileName) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let output = settingsObj['files'][eCfg][fileName];
    eachSetting(output);
}

function eachSetting(obj) {
    findCombined();
    let settings = Object.keys(obj);



    let dcaBuyPercentages = [];
    let dcaBuyTriggers = [];
    let dcaSellTriggers = [];
    let dcaBuyPercentageMatch =
        new RegExp(/DCA_buy_percentage/, 'i');
    let dcaBuyTriggerMatch =
        new RegExp(/DCA_buy_trigger/, 'i');
    let buyOrSellStrategy =
        new RegExp(/.*_strategy/, 'i');
    let dcaSellTriggersMatch =
        new RegExp(/.*DCA_[A-Z]_sell_value_.*/, 'i');

    let dcaBuyTrigger =
        d.gEBI('default_dca_buy_trigger');
    let dcaBuyPercentage =
        d.gEBI('default_dca_buy_percentage');
    let dcaSellTrigger = ''
    let dcaSellTriggerList = {};
    settings.forEach(function (x) {
        let descrips = Object.getOwnPropertyDescriptor(obj, x);
        let elId = String(x).toLowerCase();
        let setString = String(descrips.value);
        el = d.gEBI(elId);


        if (!el) {

            if (x.match(buyOrSellStrategy)) {
                x.value = 'Choose...';
                x.disabled = true;
            }
            if (x.match(dcaSellTriggersMatch)) {
                let y = x.split('_')
                let z = y.pop()
                y = y.join('_')
                let test = d.gEBI(y)
                dcaSellTrigger = test
                test ? test.disabled = false : null;
                dcaSellTriggerList[y] = [];
                dcaSellTriggerList[y].push(descrips.value);
                test ? test.value = dcaSellTriggerList[y] : null;
            }
            if (x.match(dcaBuyTriggerMatch)) {
                dcaBuyTriggers.push(descrips.value);
            }
            if (x.match(dcaBuyPercentageMatch)) {
                dcaBuyPercentages.push(descrips.value);
            }
            if (elId.split('_')[0] === 'default' &&
                currentlyEditing !== 'default') {
                let elId2 = String(currentlyEditing + '_' + elId.split('_')
                    .slice(1).join('_'));
                let el2 = d.gEBI(elId2);
                if (!el2) {
                    if (x.match(dcaBuyPercentageMatch)) {
                        dcaBuyPercentages.push(descrips.value);
                    }
                    if (x.match(dcaBuyTriggerMatch)) {
                        dcaBuyTriggers.push(descrips.value);
                    }
                    if (x.match(dcaSellTriggersMatch)) {
                        let y = x.split('_')
                        let z = y.pop()
                        y = y.join('_')
                        let test = d.gEBI(y)
                        dcaSellTrigger = test
                        test ? test.disabled = false : null;
                        dcaSellTriggerList[y] = [];
                        dcaSellTriggerList[y].push(descrips.value);
                        test ? test.value = dcaSellTriggerList[y] : null;
                    }
                } else if (!el2.classList.contains('plusminus')) {
                    if (el2.type == 'checkbox') {
                        if (setString === 'true') {
                            el2.checked = true;
                        } else if (setString === 'false') {
                            el2.checked = false;
                        }
                    }
                    if (el2.disabled) {
                        el2.disabled = false;
                        el2.value = setString;
                    }
                }
            }
            if (LS.gI(NormalizerService.generateLocalStorageKey(elId.slice(0, -2)))) {
                let newel = d.gEBI(elId.slice(0, -2));
                if (newel) {
                    let el2val =
                        String(LS.gI(NormalizerService.generateLocalStorageKey(elId.slice(0, -2))));
                    newel.value = el2val;
                    newel.disabled = false;
                }
            }
        } else {
            if (el.type === 'checkbox') {
                if (setString === 'true') {
                    el.checked = true;
                } else if (setString === 'false') {
                    el.checked = false;
                }
            } else
            if (el.disabled) {
                el.disabled = false;
            }
            el.value = setString;
        }
    });
    if (dcaBuyTriggers.length > 0) {
        if (dcaBuyTrigger) {
            dcaBuyTrigger.value = dcaBuyTriggers.join(',');
        }
    }
    if (dcaBuyPercentages.length > 0) {
        if (dcaBuyPercentage) {
            dcaBuyPercentage.value = dcaBuyPercentages.join(',');
        }
    }
    if (dcaSellTriggers.length > 0) {
        if (dcaSellTrigger) {
            dcaSellTrigger.value = dcaSellTriggers.join(',');
        }
    }
    togglePlusMinus();

}

function loadACE(filename) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    settingsObj['editingFile'] = filename;
    if (eCfg !== undefined) {
        let newarray = [];
        let myEditor = DomHelper.getGlobalEditor('PBConfigEditor');
        myEditor.focus();
        if (settingsObj['files'] !== undefined && settingsObj['files'][eCfg][filename]) {
            let data = settingsObj['files'][eCfg][filename];
            let settingName = Object.keys(data);
            forEachThenCallback(data, newarray, function () {
                let newdata = newarray.join('\n');
                myEditor.session.setValue(newdata, -1);
            })
        } else {
            myEditor.session.setValue('', -1);
        }
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        notSaved('hide');
        handleEditorContentChg(myEditor)
    }
}

function forEachThenCallback(data, newarray, cb) {
    let objkeys = Object.keys(data)
    for (let i = 0; i < objkeys.length; i++) {
        let newkey = objkeys[i];
        if (newkey.match(/comment.*/)) {
           // console.log(data[newkey]+' '+newkey)
            newarray.push(data[newkey])
        } else {
            newarray.push(newkey + ' = ' + data[newkey])
        }
    }
    cb()
}

function saveFormNewName(newName) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let pairsObj = settingsObj['files'][eCfg]['PAIRS'];
    let dcaObj = settingsObj['files'][eCfg]['DCA']
    let indicatorsObj = settingsObj['files'][eCfg]['INDICATORS'];
    let updatedText1 = '';
    let updatedText2 = '';
    let updatedText3 = '';
    notSaved('hide');
    for (x in pairsObj) {
        //console.log(x)
        updatedText1 += x + " = " + pairsObj[x] + "\n";
    }
    for (y in dcaObj) {
        updatedText2 += y + " = " + dcaObj[y] + "\n";
    }
    for (z in indicatorsObj) {
        updatedText3 += z + " = " + indicatorsObj[z] + "\n";
    }

    Service.saveAll(newName, updatedText1, updatedText2, updatedText3);
    d.qSA('.newback').forEach(function (x) {
        x.classList.remove('newback');
    })

}

function saveForm(filePath, reloader) {
    notSaved('hide');
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let obj = settingsObj['files'][eCfg][filePath];
    let updatedText = '';
    for (x in obj) {
        //console.log(x)
        updatedText += x + " = " + obj[x] + "\n";
    }
    //console.log(updatedText)
    Service.saveConfigFile(filePath, updatedText, eCfg, reloader);
    d.qSA('.newback').forEach(function (x) {
        x.classList.remove('newback');
    })
    $('#config-save-loader').css('visibility', $('#config-save-loader').css('visibility') == 'hidden' ? 'visible' : 'hidden');
}

function newConfigNameInputSave(value) {
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    value = value.replace(/[^A-Z0-9]+/ig, "_");
    let configName = settingsObj['editingConfig'];
    if (value && value !== '') {
        settingsObj['editingConfig'] = value;
        addOption('#switchActiveConfig', value);
        addOption('.config-dropdown', value);
        d.qSA('.config-dropdown').forEach(
            function (x) {
                if (x.id !== 'switchActiveConfig') {
                    x.value = value;
                }
            }
        )
        settingsObj.files[value] = settingsObj.files[configName];
        settingsObj.availableConfigs.push(value);
        LS.sO(NormalizerService.generateLocalStorageKey('settings'), settingsObj);
        saveFormNewName(value);
        //loadConfigForEditing(value);
        //storeConfigLoadForEdit(value)
    } else {
        alert('Pick a name!');
    }
}

function backup() {
    notSaved('hide');
    let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
    let eCfg = settingsObj['editingConfig'];
    let pairsObj = settingsObj['files'][eCfg]['PAIRS'];
    let dcaObj = settingsObj['files'][eCfg]['DCA'];
    let indicatorsObj = settingsObj['files'][eCfg]['INDICATORS'];
    let updatedText1 = '';
    let updatedText2 = '';
    let updatedText3 = '';
    for (x in pairsObj) {
        updatedText1 += x + " = " + pairsObj[x] + "\n";
    }
    for (y in dcaObj) {
        updatedText2 += y + " = " + dcaObj[y] + "\n";
    }
    for (z in indicatorsObj) {
        updatedText3 += z + " = " + indicatorsObj[z] + "\n";
    }
    download(updatedText1.replace(/comment.*?\ =\ /gm, "", ), eCfg + "-PAIRS.txt", "text/plain");
    download(updatedText2.replace(/comment.*?\ =\ /gm, "", ), eCfg + "-DCA.txt", "text/plain");
    download(updatedText3.replace(/comment.*?\ =\ /gm, "", ), eCfg + "-INDICATORS.txt", "text/plain");
}

function notSaved(showOrhide) {
    if (showOrhide === 'show') {
        d.qSA('.show-save-message').forEach(
            function (el) {
                el.classList.add('not-saved');
                el.style.display = 'inline-block';
            }
        )
    } else {
        d.qSA('.show-save-message').forEach(
            function (el) {
                el.classList.remove('not-saved');
                el.style.display = 'none';
            }
        )
    }
}

function handleEditorContentChg(editor) {
    editor.getSession().on('change', function () {
        let settingsObj = LS.gO(NormalizerService.generateLocalStorageKey('settings'));
        if (settingsObj == null || settingsObj['editingFile'] === 'HOTCONFIG') {
            return;
        }
        d.qSA('.show-save-message').forEach(
            function (el) {
                el.classList.add('not-saved');
                el.style.display = 'inline-block';
            }
        )
    });
}

function RateLimit(fn, delay, context) {
    let queue = [],
        timer = null;

    function processQueue() {
        let item = queue.shift();
        if (item)
            fn.apply(item.context, item.arguments);
        if (queue.length === 0)
            clearInterval(timer), timer = null;
    }
    return function limited() {
        queue.push({
            context: context || this,
            arguments: [].slice.call(arguments)
        });
        if (!timer) {
            processQueue(); // start immediately on the first invocation
            timer = setInterval(processQueue, delay);
        }
    }
}